(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/material/button'), require('@angular/material/autocomplete'), require('rxjs'), require('rxjs/operators'), require('@angular/common'), require('@angular/material/icon'), require('@angular/material/input'), require('@angular/material/menu'), require('@angular/flex-layout'), require('ngx-ellipsis'), require('@npcz/ngx-highlight')) :
    typeof define === 'function' && define.amd ? define('@npcz/ngx-search-bar', ['exports', '@angular/core', '@angular/forms', '@angular/material/button', '@angular/material/autocomplete', 'rxjs', 'rxjs/operators', '@angular/common', '@angular/material/icon', '@angular/material/input', '@angular/material/menu', '@angular/flex-layout', 'ngx-ellipsis', '@npcz/ngx-highlight'], factory) :
    (global = global || self, factory((global.npcz = global.npcz || {}, global.npcz['ngx-search-bar'] = {}), global.ng.core, global.ng.forms, global.ng.material.button, global.ng.material.autocomplete, global.rxjs, global.rxjs.operators, global.ng.common, global.ng.material.icon, global.ng.material.input, global.ng.material.menu, global.ng.flexLayout, global.ngxEllipsis, global.npczNgxHighlight));
}(this, (function (exports, core, forms, button, autocomplete, rxjs, operators, common, icon, input, menu, flexLayout, ngxEllipsis, ngxHighlight) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    // Copyright (c) 2019-2020 The Authors.
    var SearchBarComponent = /** @class */ (function () {
        function SearchBarComponent(_fb) {
            this._fb = _fb;
            this.highlightStyle = {
                hover: 'background',
                focus: 'outline',
            };
            this.search = new core.EventEmitter();
            this.changes = new core.EventEmitter();
            this.searchQuery = '';
            this._searchForm = this._fb.group({
                searchInput: null,
            });
            // Automatic unsubscription when the component is destroyed
            this._ngUnsubscribe$ = new rxjs.Subject();
        }
        Object.defineProperty(SearchBarComponent.prototype, "autoComplete", {
            get: function () {
                return this._autoComplete;
            },
            set: function (value) {
                this._autoComplete = value;
                this._setupAutoCompleteSelectionHandler();
            },
            enumerable: true,
            configurable: true
        });
        SearchBarComponent.prototype.ngOnInit = function () {
            var _this = this;
            this._searchForm
                .get('searchInput')
                .valueChanges.pipe(operators.takeUntil(this._ngUnsubscribe$))
                .subscribe(function (value) {
                _this.searchQuery = value;
                console.debug("emit changes: " + _this.category + " / " + _this.searchQuery);
                _this.changes.emit({
                    category: _this.category,
                    query: _this.searchQuery,
                });
            });
        };
        SearchBarComponent.prototype.ngOnDestroy = function () {
            // The emitted value is not important and not to be used, but is here
            // simply because it does not make sense to call next() with no value...
            this._ngUnsubscribe$.next(true);
            // Security measure to avoid memory leaks, as calling complete on
            // the source stream will remove the references to all the subscribed
            // observers, allowing the garbage collector to eventually dispose any
            // non unsubscribed Subscription instance.
            this._ngUnsubscribe$.complete();
        };
        SearchBarComponent.prototype.clear = function () {
            this._searchForm.get('searchInput').setValue('');
            this._setFocusToSearchInput();
        };
        SearchBarComponent.prototype.enable = function () {
            this.disabled = false;
        };
        SearchBarComponent.prototype.disable = function () {
            this.clear();
            this.disabled = true;
        };
        SearchBarComponent.prototype.focus = function () {
            this._setFocusToSearchInput();
        };
        SearchBarComponent.prototype._onCategorySelected = function (value) {
            this.category = value;
            console.debug("emit changes: " + this.category + " / " + this.searchQuery);
            this.changes.emit({
                category: this.category,
                query: this.searchQuery,
            });
        };
        SearchBarComponent.prototype._onCategoryMenuClosed = function () {
            this._setFocusToSearchInput();
        };
        SearchBarComponent.prototype._onSubmit = function () {
            console.debug("submit: " + this.category + " / " + this.searchQuery);
            this.search.emit({
                category: this.category,
                query: this.searchQuery,
            });
            this._searchInput.nativeElement.blur();
        };
        SearchBarComponent.prototype._setupAutoCompleteSelectionHandler = function () {
            var _this = this;
            this._autoComplete.optionSelected
                .pipe(operators.takeUntil(this._ngUnsubscribe$))
                .subscribe(function () {
                // Trigger a form submit by clicking the submit button
                _this._submitButton._elementRef.nativeElement.click();
            });
        };
        SearchBarComponent.prototype._setFocusToSearchInput = function () {
            this._searchInput.nativeElement.focus();
            // Move the cursor to the end of the text input value so that the user is
            // ready to type
            this._moveCursorToEnd();
        };
        SearchBarComponent.prototype._moveCursorToEnd = function () {
            var el = this._searchInput.nativeElement;
            if (typeof el.selectionStart == 'number') {
                el.selectionStart = el.selectionEnd = el.value.length;
            }
            else if (typeof el.createTextRange != 'undefined') {
                var range = el.createTextRange();
                range.collapse(false);
                range.select();
            }
        };
        SearchBarComponent.ctorParameters = function () { return [
            { type: forms.FormBuilder }
        ]; };
        __decorate([
            core.ViewChild('search__input'),
            __metadata("design:type", core.ElementRef)
        ], SearchBarComponent.prototype, "_searchInput", void 0);
        __decorate([
            core.ViewChild('search__submit'),
            __metadata("design:type", button.MatButton)
        ], SearchBarComponent.prototype, "_submitButton", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], SearchBarComponent.prototype, "placeholder", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], SearchBarComponent.prototype, "clearButton", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Array)
        ], SearchBarComponent.prototype, "categoryList", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], SearchBarComponent.prototype, "category", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], SearchBarComponent.prototype, "disabled", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], SearchBarComponent.prototype, "highlightStyle", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", autocomplete.MatAutocomplete),
            __metadata("design:paramtypes", [autocomplete.MatAutocomplete])
        ], SearchBarComponent.prototype, "autoComplete", null);
        __decorate([
            core.Output(),
            __metadata("design:type", Object)
        ], SearchBarComponent.prototype, "search", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", Object)
        ], SearchBarComponent.prototype, "changes", void 0);
        SearchBarComponent = __decorate([
            core.Component({
                selector: 'hc-search-bar',
                template: "<form\n  [formGroup]=\"_searchForm\"\n  id=\"search__wrapper\"\n  class=\"search__wrapper\"\n  [hcHighlight]=\"highlightStyle\"\n  (ngSubmit)=\"_onSubmit()\"\n>\n  <div class=\"search__container\" fxLayout=\"row\">\n    <!--\n      Set the type to 'button' so that the only submit button in the form is\n      the 'search__submit' button\n    -->\n    <button\n      type=\"button\"\n      *ngIf=\"categoryList\"\n      mat-stroked-button\n      class=\"search-category__button\"\n      [disabled]=\"disabled\"\n      [matMenuTriggerFor]=\"appMenu\"\n      (menuClosed)=\"_onCategoryMenuClosed()\"\n    >\n      <div fxLayout=\"row\" fxFlex=\"grow\">\n        <div\n          class=\"search-category__text\"\n          fxFlex=\"grow\"\n          ellipsis\n          [ellipsis-content]=\"category\"\n        ></div>\n        <mat-icon fxFlexAlign=\"center\">arrow_drop_down</mat-icon>\n      </div>\n    </button>\n\n    <!--\n      Because autocomplete is optional, we avoid errors on the input field by\n      setting the matAutocompleteDisabled property based on whether we do have\n      an autoComplete component set or not.\n    -->\n    <input\n      #search__input\n      type=\"text\"\n      matInput\n      class=\"search__input\"\n      fxFlex=\"grow\"\n      [placeholder]=\"placeholder\"\n      formControlName=\"searchInput\"\n      [matAutocomplete]=\"autoComplete\"\n      [matAutocompleteDisabled]=\"!autoComplete\"\n    />\n    <div *ngIf=\"searchQuery && clearButton\" fxLayout=\"row\">\n      <!--\n        Set the type to 'button' so that the only submit button in the form is\n        the 'search__submit' button\n      -->\n      <button\n        type=\"button\"\n        mat-icon-button\n        aria-label=\"Clear\"\n        (click)=\"clear()\"\n      >\n        <mat-icon>close</mat-icon>\n      </button>\n      <div fxFlexAlign=\"center\" class=\"clear__separator\"></div>\n    </div>\n    <!-- This is the only button that must be set with type 'submit' -->\n    <button #search__submit type=\"submit\" mat-icon-button [disabled]=\"disabled\">\n      <mat-icon>search</mat-icon>\n    </button>\n  </div>\n</form>\n\n<mat-menu #appMenu=\"matMenu\">\n  <ng-template matMenuContent>\n    <button\n      *ngFor=\"let category of categoryList\"\n      (click)=\"_onCategorySelected(category)\"\n      mat-menu-item\n    >\n      {{ category }}\n    </button>\n  </ng-template>\n</mat-menu>\n",
                styles: [".clear__separator{border-right:thin solid;border-color:#a9a9a9;width:5px;height:60%;margin-right:5px}.search__input{border:none;outline:0;margin:0}.search__wrapper{margin:4px;padding:5px;border-radius:8px}.search-category__button{padding:0 0 0 5px;margin-right:5px;min-width:80px;max-width:160px;flex:1 0 20%}.search-category__text{overflow:hidden}"]
            }),
            __metadata("design:paramtypes", [forms.FormBuilder])
        ], SearchBarComponent);
        return SearchBarComponent;
    }());

    // Copyright (c) 2019-2020 The Authors.
    var SearchBarModule = /** @class */ (function () {
        function SearchBarModule() {
        }
        SearchBarModule = __decorate([
            core.NgModule({
                imports: [
                    // Angular
                    common.CommonModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                    // Material
                    icon.MatIconModule,
                    button.MatButtonModule,
                    input.MatInputModule,
                    menu.MatMenuModule,
                    autocomplete.MatAutocompleteModule,
                    // Other external dependencies
                    flexLayout.FlexLayoutModule,
                    ngxEllipsis.EllipsisModule,
                    ngxHighlight.HighlightModule,
                ],
                declarations: [SearchBarComponent],
                exports: [SearchBarComponent],
            })
        ], SearchBarModule);
        return SearchBarModule;
    }());

    exports.SearchBarComponent = SearchBarComponent;
    exports.SearchBarModule = SearchBarModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=npcz-ngx-search-bar.umd.js.map
